use std::ops::Deref;

struct MyBox<T>(T);

impl<T> MyBox<T> {
    fn new(x: T) -> MyBox<T> {
        MyBox(x)
    }
}

impl<T> Deref for MyBox<T> {
    type Target = T;

    fn deref(&self) -> &T {
        &self.0
    }
}

fn main() {
    let x: Box<i32> = Box::new(5);
    println!("x={}", x);

    let x:i32 = 2;
    let y: &i32 = &x;
    let z: Box<i32> = Box::new(x);

    assert_eq!(2, x);
    assert_eq!(2, *y);
    assert_eq!(2, *z);

    let z: MyBox<i32> = MyBox::new(2);
    assert_eq!(2, *z);
}
